package com.vendor.burn.model.devices.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.BurnContext;
import com.vendor.burn.model.PartitionInfo;
import com.vendor.burn.model.PartitionItem;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.devices.IOneImageBurner;
import com.vendor.burn.model.devices.ITab;
import com.vendor.burn.model.devices.burners.FastbootBurner;
import com.vendor.burn.serial.workers.AbstractBurnerWorker;
import com.vendor.burn.serial.workers.OneImageBurnerWorker;
import com.vendor.burn.ui.burners.tabs.OneImageTab;
import java.io.File;
import java.util.List;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.IJobChangeListener;
import org.eclipse.core.runtime.jobs.Job;

public class OneImageBurner extends FastbootBurner implements IBurner, IOneImageBurner {
  private PartitionInfo info = new PartitionInfo();
  
  private boolean isHasAllinone = false;
  
  public OneImageBurner(BurnContext burnContext) {
    super(burnContext);
  }
  
  public List<PartitionItem> getChildren() {
    return this.info.getChildren();
  }
  
  protected OneImageBurnerWorker getBurnerWorker() {
    return new OneImageBurnerWorker(getFrameSetting(), this);
  }
  
  public void burn(IFastbootProgressMonitor fastbootMonitor) {
    OneImageBurnerWorker worker = getBurnerWorker();
    worker.setProgressMonitor(fastbootMonitor);
    Object object = new Object(this, "Burn Image", worker, fastbootMonitor);
    showProgressDialog((Job)object);
    object.addJobChangeListener((IJobChangeListener)new Object(this, fastbootMonitor));
    object.schedule();
  }
  
  public List<String> getSteps() {
    return null;
  }
  
  public ITab getTab() {
    return (ITab)new OneImageTab();
  }
  
  public IStatus checkBeforeBurn() {
    IStatus validLocalConfig = validSerialPort();
    if (!isOK(validLocalConfig))
      return validLocalConfig; 
    return checkHasSelectNullFile();
  }
  
  private IStatus checkHasSelectNullFile() {
    if (getChildren() == null || getChildren().size() <= 0)
      return error(Messages.pleaseSelectBurnFile); 
    List<PartitionItem> parts = getChildren();
    for (PartitionItem item : parts) {
      if (item.isChecked())
        return Status.OK_STATUS; 
    } 
    return error(Messages.pleaseSelectBurnFile);
  }
  
  public File getPartitionFile() {
    return null;
  }
  
  public PartitionInfo getPratitionInfo() {
    return this.info;
  }
  
  public void setPartitionFile(File partitionFile) {}
  
  public void remove(PartitionItem partitionItem) {}
  
  public void setTableFile(File tableFile) {}
  
  public void createImage(IFastbootProgressMonitor monitor) {}
  
  public IStatus checkCreateImage() {
    return null;
  }
  
  public boolean isHasAllinone() {
    return this.isHasAllinone;
  }
  
  public void setHasAllinone(boolean isHasAllinone) {
    this.isHasAllinone = isHasAllinone;
  }
}
